----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 25.03.2018
-- Design Name: 
-- Module Name: 
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity statistic is
generic (
  SIZE : integer := 4
);
port ( 
      CLK_IN : in std_logic;
      RESET_IN : in std_logic;
      TRIGGER_IN : in std_logic;
      COUNT_OUT : out std_logic_vector(SIZE-1 downto 0);
      OVERFLOW_OUT : out std_logic;
      DETECTED_OUT : out std_logic
      );
end statistic;

architecture Behavioral of statistic is

signal c_trigger_wait_i : std_logic_vector(7 downto 0) := (others => '0');
signal n_trigger_wait_i : std_logic_vector(7 downto 0) := (others => '0');
signal t_en_i : std_logic := '0';
signal trigger_i : std_logic_vector(7 downto 0) := (others => '0');
signal c_reg_i : std_logic_vector(SIZE-1 downto 0):= (others => '0');
signal n_reg_i : std_logic_vector(SIZE-1 downto 0):= (others => '0');
constant const_ones_i : std_logic_vector(SIZE-1 downto 0):= (others => '1');
signal c_overflow_i : std_logic := '0';
signal n_overflow_i : std_logic := '0';

begin

trigger_i(0) <= TRIGGER_IN;
shift_gen : for index in 1 to trigger_i'length-1 generate
  trig: process (CLK_IN)
  begin
     if (rising_edge(CLK_IN)) then
        if(RESET_IN='1') then
          trigger_i(index) <= '0';
        else 
          trigger_i(index) <= trigger_i(index-1);
        end if;
     end if;
  end process;
end generate;

reg: process (CLK_IN)
begin
   if (rising_edge(CLK_IN)) then
      if(RESET_IN='1') then
        c_reg_i <= (others => '0');
        c_overflow_i <= '0';
      else 
        c_reg_i <= n_reg_i;
        c_overflow_i <= n_overflow_i;
      end if;
   end if;
end process;

wait_reg: process (CLK_IN)
begin
   if (rising_edge(CLK_IN)) then
      if(RESET_IN='1') then
        c_trigger_wait_i <= (others => '1'); --enabled on default
      else 
        c_trigger_wait_i <= n_trigger_wait_i;
      end if;
   end if;
end process;
n_trigger_wait_i <= x"00"  when trigger_i(trigger_i'length-1)='0' and trigger_i(trigger_i'length-2)='1' else c_trigger_wait_i when c_trigger_wait_i= (x"FF") else std_logic_vector(to_unsigned(to_integer(unsigned(c_trigger_wait_i))+1, c_trigger_wait_i'length));
t_en_i <= '0' when c_trigger_wait_i /= (x"FF") else '1';
-- +1 on rising edge
n_reg_i <=  std_logic_vector(to_unsigned(to_integer(unsigned(c_reg_i))+1, c_reg_i'length)) when (trigger_i(trigger_i'length-1)='0' and trigger_i(trigger_i'length-2)='1') and t_en_i='1' else c_reg_i;

DETECTED_OUT <= '1' when(trigger_i(trigger_i'length-1)='0' and trigger_i(trigger_i'length-2)='1') and t_en_i='1' else '0';
-- DETECTED_OUT <= trigger_i(trigger_i'length-1);

n_overflow_i <= '1' when c_reg_i=const_ones_i else c_overflow_i;
OVERFLOW_OUT <= c_overflow_i;

COUNT_OUT <= c_reg_i;


end Behavioral;
